#include "generic.h"
// #include "getopt.h"
// #include <sys/timeb.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <math.h>

using namespace std;

inline void swap(int &a, int &b)
{
  int t;

  t = a;
  a = b;
  b = t;
} // swap

inline double sqr(double v)
{
  return v*v;
} // sqr

inline void SetPixelColor(SDL_Surface *screen, int x, int y, unsigned char red, unsigned char green, unsigned char blue)
{
  ((unsigned char*)(screen->pixels))[x*3+0 + y*screen->pitch] = red;
  ((unsigned char*)(screen->pixels))[x*3+1 + y*screen->pitch] = green;
  ((unsigned char*)(screen->pixels))[x*3+2 + y*screen->pitch] = blue;
} // SetPixelColor

inline void SetPixel(SDL_Surface* screen, int x, int y)
{
  SetPixelColor(screen, x, y, 255, 255, 255);
} // SetPixel

void SetShade(SDL_Surface *screen, int x, int y, double shade)
{
  int value = 255-((int)((fabs(shade)/1.5)*255.0));

  SetPixelColor(screen, x, y, value, value, value);
} // SetShade

int main(int argc, char** argv)
{
    SDL_Surface      *screen, *backup_screen;
    SDL_Event        event;
    SDL_Rect         dst_rect, full_image_rect, scrolled_rect, location;
    int              window_width, window_height, thumb_height, thumb_border_size;
    long             pixel_set = 0;

    window_width = 512; window_height = 512;

    if(SDL_Init(SDL_INIT_VIDEO) < 0) {
	cerr << "Could not initialize SDL video" << endl;
	exit(-1);
    } // if
    atexit(SDL_Quit);

    Uint32 flags = 0;

    // flags |= SDL_FULLSCREEN;

    screen = SDL_SetVideoMode(window_width, window_height, 24, flags);

    if(!screen) {
	cerr << "could not SetVideoMode() - abort" << endl;
	exit(-1);
    } // if

    int    y, x0, y0, x1, y1, delta_x, delta_y, dist, incE, incNE;
    double denum, shade;

    x0 = 10; y0 = 10;
    x1 = 310; y1 = 80;

    delta_x = x1-x0;
    delta_y = y1-y0;

    denum = 2.0*sqrt(delta_x*delta_x+delta_y*delta_y);
      
    dist = 2*delta_y - delta_x;
      
    incE = 2*delta_y;
    incNE = 2*(delta_y-delta_x);

    y = y0;
      
    SetPixel(screen, x0, y0);
      
    for(int x = x0; x <= x1; x++) {
      if(dist < 0) {
	shade = dist + delta_x;
	dist += incE;
      } // if
      else {
	shade = dist - delta_x;
	dist += incNE;
	y++;
      } // else
	
      SetShade(screen, x, y+1, (shade-2.0*delta_x)/denum);
      SetShade(screen, x, y, shade/denum);
      SetShade(screen, x, y-1, (shade+2.0*delta_x)/denum);

      SetPixel(screen, x, y+50);
    } // for

    SDL_UnlockSurface(screen);
    SDL_UpdateRect(screen, 0, 0, window_width, window_height);
    SDL_LockSurface(screen);

    for(;;) {
      
      SDL_WaitEvent(&event);
      /*
	if((SDL_PollEvent(&event) == 0) && (event.type == SDL_KEYDOWN)) 
	    goto exit_app;
      */
	switch(event.type) {
		
	    case SDL_MOUSEMOTION:	      
		break;
		
	    case SDL_MOUSEBUTTONDOWN:
		break;
		
	    case SDL_MOUSEBUTTONUP:
		break;
		
	    case SDL_KEYDOWN:
		
		switch(event.key.keysym.sym) {
		    
		    case 27:
		    case 'q':
		    case 'Q':
			goto exit_app;
			
		    default:
			break;
		} // switch
	} // switch

    } // for
	    
 exit_app:

    SDL_UnlockSurface(screen);	    
    SDL_FreeSurface(screen);

    exit(0);
} // main
